/*
 * This file is part of hipSYCL, a SYCL implementation based on CUDA/HIP
 *
 * Copyright (c) 2019-2020 Aksel Alpay
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef HIPSYCL_COMMON_CONFIG_HPP
#define HIPSYCL_COMMON_CONFIG_HPP

#define ACPP_VERSION_MAJOR 24
#define ACPP_VERSION_MINOR 02
#define ACPP_VERSION_PATCH 0
#define ACPP_VERSION_SUFFIX ""

#define HIPSYCL_VERSION_MAJOR ACPP_VERSION_MAJOR
#define HIPSYCL_VERSION_MINOR ACPP_VERSION_MINOR
#define HIPSYCL_VERSION_PATCH ACPP_VERSION_PATCH

#define HIPSYCL_INSTALL_PREFIX "/usr"
#define HIPSYCL_RT_LIBRARY_NAME "libacpp-rt.dylib"
#define HIPSYCL_COMMON_LIBRARY_NAME ""

// Macros to switch between proper std::filesystem, experimental version found in GCC 7, or Boost::filesystem
#define HIPSYCL_CXX_FILESYSTEM_HEADER <filesystem>
#define HIPSYCL_CXX_FILESYSTEM_NAMESPACE std::filesystem

#endif

