/*
 * This file is part of hipSYCL, a SYCL implementation based on CUDA/HIP
 *
 * Copyright (c) 2020 Aksel Alpay
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef HIPSYCL_LIBKERNEL_HOST_BACKEND_HPP
#define HIPSYCL_LIBKERNEL_HOST_BACKEND_HPP

// Any C++ compiler can do that, so this should always work
#define HIPSYCL_LIBKERNEL_COMPILER_SUPPORTS_HOST 1

// We are in the "device pass" for the host target
// if we are not in an actual device pass OR we
// are using a compiler that has a unified pass for
// host and device.
#if !defined(HIPSYCL_LIBKERNEL_DEVICE_PASS) ||                                 \
    HIPSYCL_LIBKERNEL_IS_UNIFIED_HOST_DEVICE_PASS
#define HIPSYCL_LIBKERNEL_IS_DEVICE_PASS_HOST 1

// TODO: Do we need those still?
#ifndef HIPSYCL_UNIVERSAL_TARGET
#define HIPSYCL_UNIVERSAL_TARGET
#endif

#ifndef HIPSYCL_KERNEL_TARGET
#define HIPSYCL_KERNEL_TARGET
#endif

#ifndef HIPSYCL_HOST_TARGET
#define HIPSYCL_HOST_TARGET
#endif

#else
 #define HIPSYCL_LIBKERNEL_IS_DEVICE_PASS_HOST 0
#endif
#endif
